#ifndef _INC_RESOURCE
#define _INC_RESOURCE
// ==========================================================Purpose 
// RESOURCE.H - Application resource definitions. 
// 
// MAKEMDI adaptation of Windows 3.1 SDK MAKEAPP system. 
// 
// MDI application design based on Chapter 7 of	 
// "Windows 3: A Developer's Guide" by Jeffrey Richter. 
// 
// Adaptation developed with permission of the author by  
// John F. Holliday, Technisoft Corporation 
// Telephone: (515) 472-9803, CompuServe: 71271,634 
//
// [DMM]	25-Nov-1992: Fixed crashing on exit
//			Also tabified file to tabsize of 4
//
//			David M. Miller, Business Visions, Inc.
//			Telephone: (212) 747-6118
//			CompuServe: 72676,327
//			internet: dmiller@hera.sbi.com
// ==========================================================Private 

//-Menu commands--------------------------------------------------- 

#define CMD_FILEOPENSHEET			   101
#define CMD_FILEOPENCHART			   102
#define CMD_FILESAVE				   104
#define CMD_FILESAVEAS				   105
#define CMD_FILEPRINT				   106
#define CMD_FILEPRINTERSETUP		   107
#define CMD_EXIT					   108

#define CMD_EDITCUT					   110
#define CMD_EDITCOPY				   111
#define CMD_EDITPASTE				   112

#define CMD_SHEETOPTION				   120

#define CMD_CHARTOPTION				   130

#define CMD_OPTIONSSTATUS			   140
#define CMD_OPTIONSRIBBON			   141

#define CMD_HELPINDEX				   150
#define CMD_HELPKEYBOARD			   151
#define CMD_HELPCOMMANDS			   152
#define CMD_HELPPROCEDURES			   153
#define CMD_HELPUSINGHELP			   154
#define CMD_ABOUT					   155

#define CMD_WINDOWTILEVERT			   160
#define CMD_WINDOWTILEHORIZ			   161
#define CMD_WINDOWCASCADE			   162
#define CMD_WINDOWARRANGEICONS		   163
#define CMD_WINDOWCHILD				   164


// String table constants. 

#define IDS_FONT					   100		// ribbon combobox fonts 
#define IDS_SIZE					   200		// ribbon combobox sizes 

#define IDS_APPCAPTION				   300		// Application strings 
#define IDS_APPNAME					   301

#define IDS_FRAMEPOPUPID			   1000		// Frame window menu 
#define IDS_FRAMEMENUID				   2000

#define IDS_SHEETPOPUPID			   3000		// Sheet window menu 
#define IDS_SHEETMENUID				   4000

#define IDS_CHARTPOPUPID			   5000		// Chart window menu 
#define IDS_CHARTMENUID				   6000

#define IDS_FRAMESTATUSBAR			   7000		// Status bar contents 
#define IDS_SHEETSTATUSBAR			   7001		// when no menu is open. 
#define IDS_CHARTSTATUSBAR			   7002



// Identifiers to help use string tables for menu help descriptions for	 
// menu items in the Application and MDI Child system menus. 

#define CMD_SYSMENUSIZE				   0x00		/* ((SC_SIZE & 0x0FFF)		 >>
												   4) */
#define CMD_SYSMENUMOVE				   0x01		/* ((SC_MOVE & 0x0FFF)		 >>
												   4) */
#define CMD_SYSMENUMINIMIZE			   0x02		/* ((SC_MINIMIZE & 0x0FFF)	 >>
												   4) */
#define CMD_SYSMENUMAXIMIZE			   0x03		/* ((SC_MAXIMIZE & 0x0FFF)	 >>
												   4) */
#define CMD_SYSMENUNEXTWINDOW		   0x04		/* ((SC_NEXTWINDOW & 0x0FFF) >>
												   4) */
#define CMD_SYSMENUCLOSE			   0x06		/* ((SC_CLOSE & 0x0FFF)		 >>
												   4) */
#define CMD_SYSMENURESTORE			   0x12		/* ((SC_RESTORE & 0x0FFF)	 >>
												   4) */
#define CMD_SYSMENUTASKLIST			   0x13		/* ((SC_TASKLIST & 0x0FFF)	 >>
												   4) */


//-Dialog identifiers---------------------------------------------- 

#define DLG_RIBBON					   1

// Control identifiers 

#define CTL_VERSION					   200
#define CTL_BOLD					   105
#define CTL_FONT					   101
#define CTL_FONTTEXT				   102
#define CTL_ITALIC					   106
#define CTL_SIZE					   104
#define CTL_SIZETEXT				   103
#define CTL_UNDERLINE				   107


// Generic control IDs 

#define CTL_OK									  IDOK
#define CTL_CANCEL							   IDCANCEL


// Resource ID definitions 

#define IDR_FRAMEICON				   1
#define IDR_FRAMEMENU				   1

#define IDR_SHEETICON				   2
#define IDR_SHEETMENU				   2
#define IDR_SHEETACCEL				   2

#define IDR_CHARTICON				   3
#define IDR_CHARTMENU				   3
#define IDR_CHARTACCEL				   3


//-----------------------------------------------------------Public 
//--------------------------------------------------------------End 
#endif							// !_INC_RESOURCE 
