#ifndef CLASS_RIBBON
#define CLASS_RIBBON "MakeMDI_Ribbon"
// ==========================================================Purpose 
// CHART.H - MDI ribbon dialog. 
// 
// MAKEMDI adaptation of Windows 3.1 SDK MAKEAPP system. 
// 
// MDI application design based on Chapter 7 of	 
// "Windows 3: A Developer's Guide" by Jeffrey Richter. 
// 
// Adaptation developed with permission of the author by  
// John F. Holliday, Technisoft Corporation 
// Telephone: (515) 472-9803, CompuServe: 71271,634 
//
// [DMM]	25-Nov-1992: Fixed crashing on exit
//			Also tabified file to tabsize of 4
//
//			David M. Miller, Business Visions, Inc.
//			Telephone: (212) 747-6118
//			CompuServe: 72676,327
//			internet: dmiller@hera.sbi.com
// ==========================================================Private 

// Dialog procedure 

BOOL CALLBACK _export Ribbon_DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT			RibbonDlg_DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

// Default message handler 

#define RibbonDlg_DefProc(hwnd, msg, wParam, lParam)	\
	DefDlgProcEx(hwnd, msg, wParam, lParam, &fDefDlgEx)

// Message handlers 

BOOL			RibbonDlg_OnInitDialog(HWND hDlg, HWND hwndFocus, LPARAM lParam);
VOID			RibbonDlg_OnCommand(HWND hDlg, UINT id, HWND hwndCtl, UINT codeNotify);
VOID			RibbonDlg_OnEnable(HWND hDlg, BOOL fEnable);
VOID			RibbonDlg_OnPaint(HWND hDlg);

// ===========================================================Public 

// ==============================================================End 
#endif							// !CLASS_RIBBON 
